Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpBedmachineAntarctica.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpBedmachineAntarctica.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpBedmachineAntarctica.m	(revision 26744)
@@ -1,57 +1,64 @@
-function output = interpBedmachineAntarctica(X,Y,string,method,ncdate),
+function output = interpBedmachineAntarctica(X,Y,string,method,ncdate)
+%INTERPBEDMACHINEANTARCTICA - interpolate BedMachine data onto X and Y
+%
+%   Examples:
+%      bed       = interpBedmachineAntarctica(X,Y,'bed');
+%      surface   = interpBedmachineAntarctica(X,Y,'surface');
+%      thickness = interpBedmachineAntarctica(X,Y,'thickness');
+%      mask      = interpBedmachineAntarctica(X,Y,'mask');
+%      mask      = interpBedmachineAntarctica(X,Y,'mask','nearest','../Data/BedMachineAntarctica_2020-07-15_v02.nc');
+%
+%   - mask:   0 ocean, 1 land (ice free), 2 grounded ice, 3 floating ice
+%   - source: 1 IBCSO/RTopo-2, 2 MC, 3 interpolation, 4 hydrostatic eq, 
+%             5 Streamline diffusion, 6 Gravity inversion
+%   - optional 4th input argument: interpolation method.
+%             Supported interpolation methos: 'linear','cubic','nearest'
+%   - optional 5th input argument: path to dataset.
+%
+% Version 11/30/2018 Mathieu Morlighem mmorligh@uci.edu
 
 if nargin<3, string = 'bed'; end
 if nargin<4
 	if strcmp(string,'mask') | strcmp(string,'source')
-      method='nearest'; % default method
-   else
-      method='cubic'; % default method
-   end
+		method='nearest'; % default method
+	else
+		method='cubic'; % default method
+	end
 end
 if nargin<5
-	%ncdate='2014-03-12';
-	%ncdate='2014-04-28';
-	%ncdate='2014-07-31';
-	%ncdate='2014-09-23';
-	%ncdate='2015-11-06';
-	%ncdate='2015-12-09';
-	ncdate='2016-06-10';
-	ncdate='2016-08-26';
-	ncdate='2016-11-17';
-	ncdate='2017-01-05';
-	ncdate='2017-03-10';
-	ncdate='2018-02-02';
-	ncdate='2018-03-20';
-	ncdate='2018-05-18';
-	ncdate='2018-06-08';
-	ncdate='2018-09-26';
-	ncdate='2018-11-14';
-	ncdate='2019-01-30';
-	ncdate='2019-03-12';
-	ncdate='2019-04-02';
-	ncdate='2019-04-15'; % no need of firn correction
-	ncdate='2020-06-18';
-	ncdate='2020-07-15'; %BedMachine v2?
+	ncdate='2020-07-15'; %BedMachine v2
+	ncdate='2021-11-16'; %BedMachine v2
 end
-
 basename = 'BedMachineAntarctica';
 
-%read data
-switch (oshostname()),
-	case {'ronne'}
-		nc=['/home/ModelData/Antarctica/BedMachine/' basename '-' ncdate '.nc'];
-	case {'thwaites','murdo','astrid'}
-		nc=['/u/astrid-r1b/ModelData/BedMachine/' basename '-' ncdate '.nc'];
-	otherwise
-		error('hostname not supported yet');
-end
+if nargin==5
+	ncfile = ncdate;
+else
+	%List of common paths to try
+	paths = {...
+		['/u/astrid-r1b/ModelData/BedMachine/' basename '-' ncdate '.nc'],...
+		['/home/ModelData/Antarctica/BedMachine/' basename '-' ncdate '.nc'],...
+		['/totten_1/ModelData/Antarctica/BedMachine/' basename '-' ncdate '.nc'],...
+		['/Users/larour/ModelData/BedMachine/' basename '-' ncdate '.nc'],...
+		['./' basename '-' ncdate '.nc'],...
+		};
 
-if nargout==2,
-	string = 'bed';
+	found = 0;
+	for i=1:numel(paths)
+		if exist(paths{i},'file')
+			ncfile = paths{i};
+			found = 1;
+			break;
+		end
+	end
+
+	if ~found
+		error(['Could not find ' basename '-' ncdate '.nc, you can add the path to the list or provide its path as a 5th argument']);
+	end
 end
 
 disp(['   -- BedMachine Antarctica version: ' ncdate]);
-xdata = double(ncread(nc,'x'));
-ydata = double(ncread(nc,'y'));
+xdata = double(ncread(ncfile,'x'));
+ydata = double(ncread(ncfile,'y'));
 
 offset=2;
@@ -59,4 +66,5 @@
 xmin=min(X(:)); xmax=max(X(:));
 posx=find(xdata<=xmax);
+if isempty(posx), posx=numel(xdata); end
 id1x=max(1,find(xdata>=xmin,1)-offset);
 id2x=min(numel(xdata),posx(end)+offset);
@@ -64,4 +72,5 @@
 ymin=min(Y(:)); ymax=max(Y(:));
 posy=find(ydata>=ymin);
+if isempty(posy), posy=numel(ydata); end
 id1y=max(1,find(ydata<=ymax,1)-offset);
 id2y=min(numel(ydata),posy(end)+offset);
@@ -69,6 +78,6 @@
 if strcmp(string,'icemask'),
 	disp(['   -- BedMachine Antarctica: loading ' string]);
-	%data  = double(ncread(nc,'mask'))';
-	data  = double(ncread(nc,'mask',[id1x id1y],[id2x-id1x+1 id2y-id1y+1],[1 1]))';
+	%data  = double(ncread(ncfile,'mask'))';
+	data  = double(ncread(ncfile,'mask',[id1x id1y],[id2x-id1x+1 id2y-id1y+1],[1 1]))';
 	xdata=xdata(id1x:id2x);
 	ydata=ydata(id1y:id2y);
@@ -77,6 +86,6 @@
 else
 	disp(['   -- BedMachine Antarctica: loading ' string]);
-	%data  = double(ncread(nc,string))';
-	data  = double(ncread(nc,string,[id1x id1y],[id2x-id1x+1 id2y-id1y+1],[1 1]))';
+	%data  = double(ncread(ncfile,string))';
+	data  = double(ncread(ncfile,string,[id1x id1y],[id2x-id1x+1 id2y-id1y+1],[1 1]))';
 	xdata=xdata(id1x:id2x);
 	ydata=ydata(id1y:id2y);
@@ -87,7 +96,5 @@
 if strcmp(string,'mask') | strcmp(string,'source'),
 	%Need nearest neighbor to avoid interpolation between 0 and 2
-	tic
 	output = InterpFromGrid(xdata,ydata,data,double(X),double(Y),'nearest');
-	toc
 	%tic
 	%output = FastInterp(xdata,ydata,data,X,Y,'nearest');
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpBedmachineGreenland.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpBedmachineGreenland.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpBedmachineGreenland.m	(revision 26744)
@@ -1,34 +1,61 @@
-function output = interpBedmachineGreenland(X,Y,string,ncdate),
+function output = interpBedmachineGreenland(X,Y,string,method,ncdate)
+%INTERPBEDMACHINEGREENLAND - interpolate BedMachine data onto X and Y
+%
+%   Examples:
+%      bed       = interpBedmachineGreenland(X,Y,'bed');
+%      surface   = interpBedmachineGreenland(X,Y,'surface');
+%      thickness = interpBedmachineGreenland(X,Y,'thickness');
+%      mask      = interpBedmachineGreenland(X,Y,'mask');
+%      mask      = interpBedmachineGreenland(X,Y,'mask','nearest','../Data/BedMachineGreenland_2020-07-15_v03.nc');
+%
+%   - mask:   0 ocean, 1 land (ice free), 2 grounded ice, 3 floating ice
+%   - source: 1 IBCSO/RTopo-2, 2 MC, 3 interpolation, 4 hydrostatic eq, 
+%             5 Streamline diffusion, 6 Gravity inversion
+%   - optional 4th input argument: interpolation method.
+%             Supported interpolation methos: 'linear','cubic','nearest'
+%   - optional 5th input argument: path to dataset.
+%
+% Version 11/30/2018 Mathieu Morlighem mmorligh@uci.edu
 
 if nargin<3, string = 'bed'; end
-if nargin<4,
+if nargin<4
+	if strcmp(string,'mask') | strcmp(string,'source')
+		method='nearest'; % default method
+	else
+		method='cubic'; % default method
+	end
+end
+if nargin<5
 	%ncdate='2015-04-27'; %BedMachine v2
 	ncdate='2017-09-25'; %BedMachine v3
 	ncdate='2020-04-14';
 end
-
 basename = 'BedMachineGreenland';
 
-%List of common paths to try
-paths = {...
-	['/u/astrid-r1b/ModelData/ModelData/MCdataset-' ncdate '.nc'],...
-	['/home/ModelData/Greenland/BedMachine/' basename '-' ncdate '.nc'],...
-	['/Users/larour/ModelData/BedMachine/' basename '-' ncdate '.nc'],...
-	['./' basename '-' ncdate '.nc'],...
-	};
+if nargin==5
+	ncfile = ncdate;
+else
+	%List of common paths to try
+	paths = {...
+		['/u/astrid-r1b/ModelData/ModelData/MCdataset-' ncdate '.nc'],...
+		['/home/ModelData/Greenland/BedMachine/' basename '-' ncdate '.nc'],...
+		['/totten_1/ModelData/Greenland/BedMachine/' basename '-' ncdate '.nc'],...
+		['/Users/larour/ModelData/BedMachine/' basename '-' ncdate '.nc'],...
+		['./' basename '-' ncdate '.nc'],...
+		};
 
-found = 0;
-for i=1:numel(paths)
-	if exist(paths{i},'file')
-		ncfile = paths{i};
-		found = 1;
-		break;
+	found = 0;
+	for i=1:numel(paths)
+		if exist(paths{i},'file')
+			ncfile = paths{i};
+			found = 1;
+			break;
+		end
+	end
+
+	if ~found
+		error(['Could not find ' basename '-' ncdate '.nc, you can add the path to the list or provide its path as a 5th argument']);
 	end
 end
-
-if ~found
-	error(['Could not find ' basename '-' ncdate '.nc, you can add the path to the list']);
-end
-
 
 disp(['   -- BedMachine Greenland version: ' ncdate]);
@@ -57,4 +84,5 @@
 
 disp(['   -- BedMachine Greenland: interpolating ' string]);
+disp(['       -- Interpolation method: ' method]);
 if strcmp(string,'mask') | strcmp(string,'source'),
 	%Need nearest neighbor to avoid interpolation between 0 and 2
@@ -64,3 +92,54 @@
 end
 
-%TEST https://www.mathworks.com/matlabcentral/fileexchange/10772-fast-2-dimensional-interpolation
+end
+function zi = FastInterp(x,y,data,xi,yi,method)
+
+	%get data size
+	[M N] = size(data);
+
+	% Get X and Y library array spacing
+	ndx = 1/(x(2)-x(1));    ndy = 1/(y(2)-y(1));
+	% Begin mapping xi and yi vectors onto index space by subtracting library
+	% array minima and scaling to index spacing
+
+	xi = (xi - x(1))*ndx;       yi = (yi - y(1))*ndy;
+
+	% Fill Zi with NaNs
+	zi = NaN(size(xi));
+
+	if strcmpi(method,'nearest'),
+		% Find the nearest point in index space
+		rxi = round(xi)+1;  ryi = round(yi)+1;
+		% Find points that are in X,Y range
+		flag = rxi>0 & rxi<=N & ~isnan(rxi) & ryi>0 & ryi<=M & ~isnan(ryi);
+		% Map subscripts to indices
+		ind = ryi + M*(rxi-1);
+		zi(flag) = data(ind(flag));
+
+	else %Bilinear
+
+		% Transform to unit square
+		fxi = floor(xi)+1;  fyi = floor(yi)+1; % x_i and y_i
+		dfxi = xi-fxi+1;    dfyi = yi-fyi+1;   % Location in unit square
+
+		% flagIn determines whether the requested location is inside of the data arrays
+		flagIn = fxi>0 & fxi<N & ~isnan(fxi) & fyi>0 & fyi<M & ~isnan(fyi);
+
+		%Toss all out-of-bounds variables now to save time
+		fxi  = fxi(flagIn);  fyi  = fyi(flagIn);
+		dfxi = dfxi(flagIn); dfyi = dfyi(flagIn);
+
+		%Find bounding vertices
+		ind1 = fyi + M*(fxi-1);     % indices of (  x_i  ,  y_i  )
+		ind2 = fyi + M*fxi;         % indices of ( x_i+1 ,  y_i  )
+		ind3 = fyi + 1 + M*fxi;     % indices of ( x_i+1 , y_i+1 )
+		ind4 = fyi + 1 + M*(fxi-1); % indices of (  x_i  , y_i+1 )
+
+		% Bilinear interpolation
+		zi(flagIn) = ...
+			data(ind1).*(1-dfxi).*(1-dfyi) + ...
+			data(ind2).*dfxi.*(1-dfyi) + ...
+			data(ind4).*(1-dfxi).*dfyi + ...
+			data(ind3).*dfxi.*dfyi;
+	end
+end
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpBedmap2.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpBedmap2.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpBedmap2.m	(revision 26744)
@@ -18,5 +18,12 @@
 %      [dataout] = interpBedmap2(X,Y,string)
 
-nc = '/home/ModelData/Antarctica/BedMap2/bedmap2_bin/Bedmap2.nc';
+switch (oshostname()),
+	case {'ronne'}
+		nc = '/home/ModelData/Antarctica/BedMap2/bedmap2_bin/Bedmap2.nc';
+	case {'totten'}
+		nc = '/totten_1/ModelData/Antarctica/BedMap2/bedmap2_bin/Bedmap2.nc';
+	otherwise
+		error('hostname not supported yet');
+end
 if exist(nc,'file')
 	if strcmp(string,'thickness_uncertainty_5km')
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpDTU19MDT.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpDTU19MDT.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpDTU19MDT.m	(revision 26744)
@@ -4,4 +4,6 @@
 	case {'ronne'}
 		rootname='/ronne_2/home/ModelData/Global/DTU19MDT/dtu19mdt.mat';
+	case {'totten'}
+		rootname='/totten_1/ModelData/Global/DTU19MDT/dtu19mdt.mat';
 	otherwise
 		error('machine not supported yet');
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpFromGeotiff.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpFromGeotiff.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpFromGeotiff.m	(revision 26744)
@@ -1,3 +1,7 @@
-function dataout = interpFromGeotiff(geotiffname,X,Y),
+function dataout = interpFromGeotiff(geotiffname,X,Y,nanValue),
+
+if nargin < 4
+	nanValue = 10^30;
+end
 
 usemap = 0;
@@ -21,10 +25,10 @@
 	%Get image info
 	Tinfo = imfinfo(geotiffname);
-	N     = Tinfo.Width;
-	M     = Tinfo.Height;
-	dx    = Tinfo.ModelPixelScaleTag(1);
-	dy    = Tinfo.ModelPixelScaleTag(2);
-	minx  = Tinfo.ModelTiepointTag(4);
-	maxy  = Tinfo.ModelTiepointTag(5);
+	N     = Tinfo(1).Width;
+	M     = Tinfo(1).Height;
+	dx    = Tinfo(1).ModelPixelScaleTag(1);
+	dy    = Tinfo(1).ModelPixelScaleTag(2);
+	minx  = Tinfo(1).ModelTiepointTag(4);
+	maxy  = Tinfo(1).ModelTiepointTag(5);
 
 	%Generate vectors
@@ -55,5 +59,9 @@
 		data=double(flipud(imread(geotiffname)));
 	end
-	data(find(abs(data)>10^30))=NaN;
+	if nanValue > 0
+		data(find(abs(data)>=nanValue))=NaN;
+	else 
+		data(find(data<=nanValue))=NaN;
+	end
 
 end
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpGeoid.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpGeoid.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpGeoid.m	(revision 26744)
@@ -6,4 +6,6 @@
 	case {'ronne'}
 		rootname='/home/ModelData/Global/Geoid/eigen-6c4-1970.mat';
+	case {'totten'}
+		rootname='/totten_1/ModelData/Global/Geoid/eigen-6c4-1970.mat';
 	otherwise
 		error('machine not supported yet');
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpIBCSO.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpIBCSO.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpIBCSO.m	(revision 26744)
@@ -6,4 +6,7 @@
 		ncpath='/home/ModelData/Antarctica/IBCSO/ibcso_v1_bed.grd';
 		sidpath='/home/ModelData/Antarctica/IBCSO/ibcso_v1_sid.grd';
+	case {'totten'}
+		ncpath='/totten_1/ModelData/Antarctica/IBCSO/ibcso_v1_bed.grd';
+		sidpath='/totten_1/ModelData/Antarctica/IBCSO/ibcso_v1_sid.grd';
 	otherwise
 		error('hostname not supported yet');
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpJoughinCompositeGreenland.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpJoughinCompositeGreenland.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpJoughinCompositeGreenland.m	(revision 26744)
@@ -2,5 +2,5 @@
 
 %data=load(['/u/astrid-r1b/morlighe/issmjpl/proj-morlighem/DatasetGreenland/Data/VelJoughin/IanGreenVel.mat']);
-filename = '/home/ModelData/Greenland/VelJoughin/IanGreenVel.mat';
+filename = '/totten_1/ModelData/Greenland/VelJoughin/IanGreenVel.mat';
 
 %Figure out what subset of the matrix should be read
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpJoughinMosaic.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpJoughinMosaic.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpJoughinMosaic.m	(revision 26744)
@@ -4,4 +4,6 @@
 	case {'ronne'}
 		filename = '/home/ModelData/Greenland/VelJoughin/IanGreenVel.mat';
+	case {'totten'}
+		filename = '/totten_1/ModelData/Greenland/VelJoughin/IanGreenVel.mat';
 	otherwise
 		error('machine not supported yet');
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpMouginotAnt2017.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpMouginotAnt2017.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpMouginotAnt2017.m	(revision 26744)
@@ -5,4 +5,6 @@
 	case {'ronne'}
 		nc = '/home/ModelData/Antarctica/MouginotVel/vel_nsidc.CF16_2.nc';
+	case {'totten'}
+		nc = '/totten_1/ModelData/Antarctica/MouginotVel/vel_nsidc.CF16_2.nc';
 	otherwise
 		error('hostname not supported yet');
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpMouginotAntTimeSeries1973to2018.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpMouginotAntTimeSeries1973to2018.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpMouginotAntTimeSeries1973to2018.m	(revision 26744)
@@ -54,4 +54,6 @@
 	case {'ronne'}
 		nc = '/home/ModelData/Antarctica/MouginotVel/ASE_TimeSeries_1973-2018.nc';
+	case {'totten'}
+		nc = '/totten_1/ModelData/Antarctica/MouginotVel/ASE_TimeSeries_1973-2018.nc';
 	otherwise
 		error('hostname not supported yet');
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpRACMOant.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpRACMOant.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpRACMOant.m	(revision 26744)
@@ -1,5 +1,12 @@
 function smb = interpRACMOant(x,y);
 
-	smbfile = '/home/ModelData/Antarctica/RACMO2SMB/SMB_RACMO2.3_1979_2011.nc';
+switch oshostname(),
+	case {'ronne'}
+		smbfile = '/home/ModelData/Antarctica/RACMO2SMB/SMB_RACMO2.3_1979_2011.nc';
+	case {'totten'}
+		smbfile = '/totten_1/ModelData/Antarctica/RACMO2SMB/SMB_RACMO2.3_1979_2011.nc';
+	otherwise
+		error('machine not supported yet');
+end
 	LAT=ncread(smbfile,'lat2d')';
 	LON=ncread(smbfile,'lon2d')';
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpREMA.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpREMA.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpREMA.m	(revision 26744)
@@ -4,4 +4,6 @@
 	case {'ronne'}
 		remapath='/home/ModelData/Antarctica/REMA/REMA_200m_dem_filled.tif';
+	case {'totten'}
+		remapath='/totten_1/ModelData/Antarctica/REMA/REMA_200m_dem_filled.tif';
 	otherwise
 		error('machine not supported yet');
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpRTopo2.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpRTopo2.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpRTopo2.m	(revision 26744)
@@ -11,4 +11,6 @@
 	case {'ronne'}
 		rootname='/home/ModelData/Global/RTopo-2/RTopo-2.0.1_30sec_bedrock_topography.nc';
+	case {'totten'}
+		rootname='/totten_1/ModelData/Global/RTopo-2/RTopo-2.0.1_30sec_bedrock_topography.nc';
 	otherwise
 		error('machine not supported yet');
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpRignot2012.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpRignot2012.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpRignot2012.m	(revision 26744)
@@ -1,5 +1,5 @@
 function [vxout vyout]= interpRignot2012(X,Y),
 
-filename = '/home/ModelData/Greenland/VelMouginot/RignotGreenland2012Vel.mat';
+filename = '/totten_1/ModelData/Greenland/VelMouginot/RignotGreenland2012Vel.mat';
 
 
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpSeaRISE.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpSeaRISE.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpSeaRISE.m	(revision 26744)
@@ -52,4 +52,10 @@
 			searisenc='/u/astrid-r1b/ModelData/SeaRISE/Antarctica5km_shelves_v1.0/Antarctica_5km_dev1.0.nc';
 		end
+	case {'totten'}
+		if hemisphere==1,
+			searisenc='/totten_1/ModelData/SeaRISE/Greenland_5km_dev1.2.nc';
+		elseif hemisphere==-1,
+			searisenc='/totten_1/ModelData/SeaRISE/Antarctica_5km_dev1.0.nc';
+		end
 	otherwise
 		error('hostname not supported yet');
Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpSmith2020.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpSmith2020.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpSmith2020.m	(revision 26744)
@@ -33,4 +33,10 @@
 			path='/home/ModelData/Antarctica/DHDTSmith/';
 		end
+	case {'totten'}
+		if strcmp(string,'gris_filt') | strcmp(string,'gris')
+			path='/totten_1/ModelData/Greenland/DHDTSmith/';
+		else
+			path='/totten_1/ModelData/Antarctica/DHDTSmith/';
+		end
 	case {'recruta'}
 		path='/home/santos/ModelData/ICESat1_ICESat2_mass_change/';
Index: issm/trunk/src/m/contrib/tsantos/integrate_field.m
===================================================================
--- issm/trunk/src/m/contrib/tsantos/integrate_field.m	(revision 26744)
+++ issm/trunk/src/m/contrib/tsantos/integrate_field.m	(revision 26744)
@@ -0,0 +1,22 @@
+function total=integrate_field(index,x,y,field)
+%INTEGRATE_FIELD: integrate a field over a 2D mesh
+%
+%   Usage:
+%      total=integrate_field(index,x,y,field);
+%
+%   Examples:
+%      volume=integrate_field(md.mesh.elements,md.mesh.x,md.mesh.y,md.geometry.thickness);
+
+% areas of each element
+x1=x(index(:,1)); x2=x(index(:,2)); x3=x(index(:,3));
+y1=y(index(:,1)); y2=y(index(:,2)); y3=y(index(:,3));
+areas=(0.5*((x2-x1).*(y3-y1)-(y2-y1).*(x3-x1)));
+
+% element-wise integration
+v1=index(:,1);	v2=index(:,2);	v3=index(:,3);
+elem_int=areas.*mean(field([v1 v2 v3]),2);
+
+% compute integration
+total=sum(elem_int);
+
+end
Index: issm/trunk/src/m/coordsystems/gdaltransform.m
===================================================================
--- issm/trunk/src/m/coordsystems/gdaltransform.m	(revision 25994)
+++ issm/trunk/src/m/coordsystems/gdaltransform.m	(revision 26744)
@@ -20,5 +20,5 @@
 %			+proj=stere +lat_0=90 +lat_ts=71 +lon_0=-39 +k=1 +x_0=0 +y_0=0 +a=6378273 +b=6356889.448564109 +units=m +no_defs
 %
-%	To get proj.4 string from EPSG, use gdalsrsinfo. Example:
+%	To get PROJ.4 string from EPSG, use gdalsrsinfo. Example:
 %		gdalsrsinfo epsg:4326 | grep "PROJ.4" | sed "s/PROJ.4 : //"
 
Index: issm/trunk/src/m/coordsystems/gmtmask.m
===================================================================
--- issm/trunk/src/m/coordsystems/gmtmask.m	(revision 25994)
+++ issm/trunk/src/m/coordsystems/gmtmask.m	(revision 26744)
@@ -35,35 +35,10 @@
 	dlmwrite(filename_all,[long lat (1:nv)'],'delimiter','\t','precision',10);
 
-	%Avoid bypassing of the ld library path by Matlab (:()
-	%
-	% TODO: Do we really need this (we can/already set it in etc/environment.sh)?
-	if ismac,
-		dyld_library_path_old=getenv('DYLD_LIBRARY_PATH');
-		setenv('DYLD_LIBRARY_PATH',[ issmdir '/externalpackages/curl/install/lib:' issmdir '/externalpackages/hdf5/install/lib:' issmdir '/externalpackages/netcdf/install/lib' ]);
-	end
-
-	%Find path to gmt, list all possible known paths to gmt (you may need to add yours to the list)
-   gmtpaths = {[issmdir '/bin/gmt'],[issmdir '/externalpackages/gmt/install/bin/gmt'],'/Applications/GMT-5.4.3.app/Contents/Resources/bin/gmt'};
-   gmtpath = '';
-   for i=gmtpaths
-      if exist(i{1},'file'),
-         gmtpath = i{1};
-			break;
-      end
-   end
-   if isempty(gmtpath),
-      error('gmt not found! Make sure it is properly installed, or add its path to this file.');
-   end
-   
 	%figure out which vertices are on the ocean, which one on the continent:
-	[status,result] = system([gmtpath ' gmtselect ./' filename_all ' -h0 -Df -R0/360/-90/90  -A0 -JQ180/200 -Nk/s/s/k/s > ./' filename_oce]);
+	[status,result] = system(['gmtselect ./' filename_all ' -h0 -Df -R0/360/-90/90  -A0 -JQ180/200 -Nk/s/s/k/s > ./' filename_oce]);
 	if status~=0,
 		error(result);
 	end
 
-	%reset DYLD_LIBRARY_PATH to what it was: 
-	if ismac,
-		setenv('DYLD_LIBRARY_PATH',dyld_library_path_old);
-	end
 	%read the con_vertices.txt file and flag our mesh vertices on the continent
 	fid=fopen(['./' filename_oce],'r');
Index: issm/trunk/src/m/coordsystems/gmtmask.py
===================================================================
--- issm/trunk/src/m/coordsystems/gmtmask.py	(revision 25994)
+++ issm/trunk/src/m/coordsystems/gmtmask.py	(revision 26744)
@@ -44,41 +44,6 @@
     np.savetxt('./all_vertices.txt', np.transpose([long, lat, np.arange(1, nv + 1)]), delimiter='\t', fmt='%.10f')
 
-    #Avoid bypassing of the ld library path by Matlab (:()
-    issm_dir = issmdir()
-
-    try:
-        ismac
-    except NameError:
-        ismac = False
-
-    # TODO: Do we really need this (we can/already set it in etc/environment.sh)?
-    if ismac:
-        dyld_library_path_old = os.getenv('DYLD_LIBRARY_PATH')
-        os.putenv('DYLD_LIBRARY_PATH', issm_dir + '/externalpackages/curl/install/lib:' + issm_dir + '/externalpackages/hdf5/install/lib:' + issm_dir + '/externalpackages/netcdf/install/lib')
-
-    #Find path to gmt (you may need to add yours to the list).
-    #
-    # NOTE: Assumes gmtselect is also in this directory.
-    #
-    gmtpaths = [
-        issm_dir + '/bin/gmt',
-        issm_dir + '/externalpackages/gmt/install/bin/gmt',
-        '/Applications/GMT-5.4.3.app/Contents/Resources/bin/gmt'
-    ]
-    gmtpath = ''
-    for i in range(len(gmtpaths)):
-        if os.path.isfile(gmtpaths[i]):
-            gmtpath = gmtpaths[i]
-            break
-
-    if gmtpath == '':
-        raise Exception('gmt not found! Make sure it is properly installed, or add its path to this file.')
-
     #figure out which vertices are on the ocean, which one on the continent:
-    subprocess.call(gmtpath + ' gmtselect ./ all_vertices.txt -h0 -Df -R0/360/-90/90 -A0 -JQ180/200 -Nk/s/s/k/s > ./oce_vertices.txt', shell=True)
-
-    #reset DYLD_LIBRARY_PATH to what it was:
-    if ismac:
-        os.putenv('DYLD_LIBRARY_PATH', dyld_library_path_old)
+    subprocess.call('gmtselect ./ all_vertices.txt -h0 -Df -R0/360/-90/90 -A0 -JQ180/200 -Nk/s/s/k/s > ./oce_vertices.txt', shell=True)
 
     #read the con_vertices.txt file and flag our mesh vertices on the continent
Index: issm/trunk/src/m/coordsystems/laea.py
===================================================================
--- issm/trunk/src/m/coordsystems/laea.py	(revision 25994)
+++ issm/trunk/src/m/coordsystems/laea.py	(revision 26744)
@@ -1,5 +1,4 @@
 def laea(lat, long): #{{{
-    '''
-    LAEA - Lambert Azimuthal Equal Area projection at lat, long projection 
+    """LAEA - Lambert Azimuthal Equal Area projection at lat, long projection 
     center.
 
@@ -10,5 +9,5 @@
             string = laea(45, -90)
             return string = '+proj=laea +lat_0=45 +lon_0=-90 +x_0=0 +y_0=0 +ellps=WGS84 +units=m +no_defs'
-    '''
+    """
 
     return '+proj=laea +lat_0={} +lon_0={} +x_0=0 +y_0=0 +ellps=WGS84 +units=m +no_defs'.format(lat, long)
Index: issm/trunk/src/m/coordsystems/laea_inv.m
===================================================================
--- issm/trunk/src/m/coordsystems/laea_inv.m	(revision 26744)
+++ issm/trunk/src/m/coordsystems/laea_inv.m	(revision 26744)
@@ -0,0 +1,63 @@
+function [lat,lon] = laea_inv(x,y,lat1,lon0,falseeasting,falsenorthing)
+% laea_inv performs an inverse Lambert Azimuthal Equal Area projection
+% for a simple spherical Earth of radius 6371000 meters. 
+% 
+%% Syntax 
+% 
+%  [lat,lon] = laea_inv(x,y,lat1,lon0)
+%  [lat,lon] = laea_inv(x,y,lat1,lon0,falseeasting,falsenorthing)
+% 
+%% Description 
+% 
+% [lat,lon] = laea_inv(x,y,lat1,lon0) transforms the coordinates x,y (in 
+% meters) into geographic coordinates lat,lon. Inputs lat1 and lon0 specify 
+% the origin.
+%
+% [lat,lon] = laea_inv(x,y,lat1,lon0,falseeasting,falsenorthing) also allows
+% inclusion of false eastings and northings in meters. 
+% 
+%% Author Info 
+% Function written by Chad A. Greene of NASA Jet Propulsion Laboratory. 
+% December 2020. 
+% Formulas taken directly from Snyder 1987's classic tome, "Map Projections 
+% A Working Manual" starting around page 185. 
+
+%% Parse inputs: 
+
+narginchk(4,6)
+assert(isequal(size(lat1),size(lon0),[1 1]),'Error: Inputs lat1 and lon0 must both be scalars.')
+assert(abs(lat1)<=90,'lat1 cannot exceed +/-90 degrees.') 
+assert(abs(lon0)<=360,'lon0 cannot exceed +/-360 degrees.') 
+assert(isequal(size(x),size(y)),'Dimensions of x and y must match.') 
+
+if nargin<5
+   falseeasting = 0; 
+   falsenorthing = 0; 
+end
+
+%% 
+% Projection formulas:
+% From Snyder 1987, MAP PROJECTIONS-A WORKING MANUAL, page 185: https://pubs.usgs.gov/pp/1395/report.pdf
+
+% Account for false easting, northing: 
+x = x - falseeasting; 
+y = y - falsenorthing; 
+
+% Define constants: 
+R = 6371000; % earth radius (meters) 
+rho = hypot(x,y); 
+c = 2*asind(rho./(2*R)); 
+
+% Unproject: 
+lat = asind(cosd(c) .* sind(lat1) + (y .* sind(c) .* cosd(lat1))./rho); 
+
+switch lon0
+   case 90
+      lon = lon0 + atand(-x./y);
+   case -90
+      lon = lon0 + atand(x./y); 
+   otherwise
+      lon = lon0 + atand((x .* sind(c))./(rho.*cosd(lat1) .*cosd(c) - y.*sind(lat1).*sind(c))); 
+end
+
+end
Index: issm/trunk/src/m/coordsystems/ll2xy.m
===================================================================
--- issm/trunk/src/m/coordsystems/ll2xy.m	(revision 25994)
+++ issm/trunk/src/m/coordsystems/ll2xy.m	(revision 26744)
@@ -36,5 +36,5 @@
 
 if nargout~=3 & nargout~=2,
-	help xy2ll
+	help ll2xy
 	error('bad usage');
 end
